SetUpConstants;

labelColors = GetColors(HOME, HOMECODE, HOMELABELSETS, Labels);

totalHeight = 900;
totalWidth = 1200;
pfig = ProgressBar('Generating Figure');
figure(1);
clf;
set(1, 'Position', [0, 0, totalWidth, totalHeight]);
imSize = .1;
rp = randperm(length(trainFileList));
for i = rp(1:1000)
    [fold base ext] = fileparts(trainFileList{i});
    [v, xml] = loadXML(fullfile(HOMEANNOTATIONS,fold,[base '.xml']));
    im = imread(fullfile(HOMEIMAGES,fold,[base ext]));
    [ro co ch] = size(im);
    scale = totalWidth*imSize/max(ro,co);
    im = imresize(im,scale);
    rx = 1;ry = 1;
    sx = 1;sy = 1;
    while(rx+sx>1 || ry+sy>1)
        rx = rand();ry = rand();
        rs = imSize;
        sx = rs*min((co/ro)*(totalHeight/totalWidth),1);sy = rs*min((ro/co)*(totalWidth/totalHeight),1);
    end
    %figure(1);
    axes('Position', [rx ry sx sy], 'XTickLabel','', 'YTickLabel','');
    imshow(im); hold on;
    for j = 1:length(v.annotation.object)
        poly.x = str2double({v.annotation.object(j).polygon.pt.x})*scale;
        poly.y = str2double({v.annotation.object(j).polygon.pt.y})*scale;
        patch(poly.x,poly.y,'r','FaceColor','none','EdgeColor',labelColors{1}(str2double(v.annotation.object(j).namendx),:),'LineWidth',2);
    end
    hold off;
    if(mod(i,20) == 0)
        drawnow;
        ProgressBar(pfig,find(i==rp),length(rp));
    end
end
close(pfig);
OutDir = 'D:\P4\jtighe_localhost\CourseWork\PhD Proposal';
export_fig(fullfile(OutDir,['full dataset(43).png']),'-transparent');