HOME = 'D:\im_parser\LMSun';
HOMEANNOTATIONS = fullfile(HOME,'Annotations');
HOMEIMAGES = fullfile(HOME,'Images');
HOMEWEB = fullfile(HOME,'AnnWeb');
HOMEWEBIM = fullfile(HOMEWEB,'Images');

if(~exist('D','var'))
    saveFile = fullfile(HOME,'D.mat');
    if(exist(saveFile,'file'))
        load(saveFile);
    else
        D = LMdatabase(HOMEANNOTATIONS);
        save(saveFile,'D');
    end
end

testSetFile = fullfile(HOME, 'TestSet1.txt');
testFileList = sort(importdata(testSetFile));
listFile = fullfile(HOME,'fileList.txt');
if(exist(listFile,'file'))
    fileList = importdata(listFile);
else
    fileList = dir_recurse(fullfile(HOMEIMAGES,'*.*'),0);
end
[a b c] = intersect(fileList,testFileList);
testMask = zeros(size(D))==1;
testMask(b) = true;
Duse= D(~testMask);

Duse = removeviewpoint(Duse);
[tn tc imageNdx b labelNdx] = LMobjectnames(Duse);

[labelCounts sortNdx] = sort(tc);%,'descend');%
labels = tn(sortNdx);

imHeight = 100;
maxCount = 800;

MyCleanUp;
indexFile = fullfile(HOMEWEB,'index.htm');make_dir(indexFile);
ifid = fopen(indexFile,'w');

for l = 1:length(labels)
    webFile = fullfile(HOMEWEB,'LabelSites',[labels{l} '.htm']);make_dir(webFile);
    lfid = fopen(webFile,'w');
    fprintf(ifid,'<a href="%s">%s: %d</a><br>\n',['LabelSites/' labels{l} '.htm'],labels{l},labelCounts(l));
    [Dlabel, j] = LMquery(Duse(unique(imageNdx(labelNdx==sortNdx(l)))), 'object.name', labels{l});
    count = 0;
    for i = 1:length(Dlabel)
        im = LMimread(Dlabel, i, HOMEIMAGES);
        [fold base] = fileparts(fullfile(Dlabel(i).annotation.folder, Dlabel(i).annotation.filename));
        [ro co c] = size(im);
        Nobjects = length(Dlabel(i).annotation.object); n=0;
        for j = 1:Nobjects
            saveFile = fullfile(HOMEWEBIM,labels{l},fold,[base num2str(j) '.jpg']);make_dir(saveFile);
            if(~exist(saveFile,'file'))
                [X,Y] = getLMpolygon(Dlabel(i).annotation.object(j).polygon);
                crop(1) = max(min(X)-10,1);
                crop(2) = min(max(X)+10,co);
                crop(3) = max(min(Y)-10,1);
                crop(4) = min(max(Y)+10,ro);
                crop = round(crop);
                imgCrop = im(crop(3):crop(4), crop(1):crop(2), :);
                scale = imHeight/size(imgCrop,1);
                imgCrop = imresize(imgCrop,scale);
                show(imgCrop,1,0);colormap gray;hold on
                plot(([X; X(1)]-crop(1)+1)*scale, ([Y; Y(1)]-crop(3)+1)*scale, 'r', 'linewidth', 2);hold off; drawnow;
                export_fig(saveFile);%,'-m0','-transparent');
            end
            fprintf(lfid,'<img src="%s">',['../Images/' labels{l} '/' strrep(fold,'\','/') '/' base num2str(j) '.jpg']);
            if(count>maxCount)
                break;
            end
            count = count + 1;
        end
        if(count>maxCount)
            break;
        end
    end
end
