SetUpConstants;

WEBLABELSETS = HOMELABELSETS(UseLabelSet);

labelColors = GetColors(HOME, HOMECODE, WEBLABELSETS, Labels(UseLabelSet));

mrfFold = 'MRF';
if(exist('testParams','var') && isfield(testParams,'MRFFold'))
    mrfFold = testParams.MRFFold;
end

MyCleanUp;
if(dbNum == 1)
elseif(dbNum == 2)
elseif(dbNum == 3)
    WebTestList = {'LF-RBF-SS250k-RH0.00-RE0.33-std-G0.0000-s_3-nt',...
    'LF-RBF-SS250k-RH0.00-RE0.33-std-G0.0000-s_3-nt-obj-thing',...
    'LF-RBF-SS250k-RH0.00-RE0.33-std-G0.0000-s_3-nt-obj-thing-SS008'};
    WebTestName = {'Linear SVM','Linear SVM Objects (Things only)','Linear SVM Objects (Things only) Smoothed'};
elseif(dbNum == 4)
    WebTestList = {'shortlist-SuperParsing',...
        'shortlist-nonull-DetectorModel468-MM0100-R468-NMS0',...
        'shortlist-LF-RBF-SS250k-RH0.00-RE0.33-std-G0.0000-s_2-C0.001-MM0100',...
        'shortlist-LF-RBF-SS250k-RH0.00-RE0.33-std-G0.0000-s_2-C0.001-MM0100-SS008'};
    WebTestName = {'Provided Marginals','Detector Score with null=0','SVM Combined','SVM Combined Smoothed'};
end

if(exist('HOMETEST','var'))
    HOMETESTSET = fullfile(HOMETESTDATA,testParams.TestString);
    HOMEWEBTESTIMAGES = HOMETESTIMAGES;
else
    HOMETESTSET = fullfile(HOMEDATA,testParams.TestString);
    HOMEWEBTESTIMAGES = HOMEIMAGES;
end
HOMEWEB = fullfile(HOMETESTSET,'Website');

webIndexFile = fullfile(HOMEWEB,'index2.htm');
webSelectedFile = fullfile(HOMEWEB,'selected.htm');
if(exist('rangeN','var'))
    webIndexFile = fullfile(HOMEWEB,sprintf('index%d%d.htm',rangeN(1),rangeN(2)));
    webSelectedFile = fullfile(HOMEWEB,sprintf('selected%d%d.htm',rangeN(1),rangeN(2)));
end
if(exist('bestClass','var') && ~isempty(bestClass))
    webIndexFile = fullfile(HOMEWEB,sprintf('index-%s.htm',bestClass));
end
make_dir(webIndexFile);
indexFID = fopen(webIndexFile,'w');
selectedFID = fopen(webSelectedFile,'w');
PrimaryLabelSet = 1;
PrimaryTestSet = 4;
SecondaryTestSet = 1;
numCols = 6;
colCount = 0;
colCountSelected = 0;
genIm = true;
sortFiles = false;
justIndex = false;

onlyLabeledArea = 1;
onlyCorrect = 1;
maxDim = 1000;

resultsStats = zeros([length(WebTestList) length(HOMELABELSETS) length(testFileList)]);

fprintf(indexFID,'\n<center>\n');
fprintf(indexFID,'\n<table border="0">\n');
fprintf(indexFID,'\t<tr VALIGN=TOP>\n');
fprintf(selectedFID,'\n<center>\n');
fprintf(selectedFID,'\n<table border="0">\n');
fprintf(selectedFID,'\t<tr VALIGN=TOP>\n');

pfig = ProgressBar('Generating Web');
range = rangeTest;
selectedNdx = [];
perLabelStats = zeros(length(Labels{PrimaryLabelSet}),max(range),2,2);
if(sortFiles)
    accGain = zeros(max(range),1);
    for i = range
        [folder base ext] = fileparts(testFileList{i});
        secondaryRestults = 0;
        for j = 1:length(WebTestList)
            for k = 1:length(WEBLABELSETS)
                [foo setBase] = fileparts(WEBLABELSETS{k});
                resultFile = fullfile(HOMETESTSET,mrfFold,setBase,WebTestList{j},folder,[base '.mat']);
                resultCache = [resultFile '.cache'];
                if(exist(resultCache,'file'))
                    load(resultCache,'-mat'); %metaData perLabelStat(#labelsx2) perPixelStat([# pix correct, # pix total]);
                end
                if(exist('perPixelStat','var'))
                    if(k==PrimaryLabelSet&&j==SecondaryTestSet)
                        secondaryRestults = 100*perPixelStat(1)/perPixelStat(2);
                        perLabelStats(:,i,:,2) = perLabelStat;
                    end
                    if(k==PrimaryLabelSet&&j==PrimaryTestSet)
                        perLabelStats(:,i,:,1) = perLabelStat;
                        if(exist('secondaryRestults','var'))
                            accGain(i) = (100*perPixelStat(1)/perPixelStat(2));%-secondaryRestults;
                        end
                    end
                end
            end
        end
    end
    [accGain rndx] = sort(accGain(range),'descend');
    range = range(rndx);
end
if(exist('bestClass','var') && ~isempty(bestClass))
    range = sort(range);
    hasLabel = perLabelStats(strcmp(names,bestClass),:,2,1);
    range(hasLabel(range)==0) = [];
    gotLabel = perLabelStats(strcmp(names,bestClass),:,1,1);
    [~, rndx] = sort(gotLabel(range),'descend');
    range = range(rndx);
end

for i = 1:range(end)
    im = imread(fullfile(HOMEWEBTESTIMAGES,testFileList{i}));
    [ro co ch] = size(im);
    [folder base ext] = fileparts(testFileList{i});
    backOutString = '../';
    if(isempty(folder))
        folder = '.';
        backOutString = '';
    else
        [f b] = fileparts(folder);
        if(~isempty(f))
            backOutString = '../../';
        end
    end
    clear secondaryRestults;
    
    %% Retrieval set code
    %{
    retWebPage = fullfile(HOMEWEB,'RetrievalWeb',folder,[base '.htm']);make_dir(retWebPage);
    retFID = fopen(retWebPage,'w');
    fprintf(retFID,'<HTML>\n<HEAD>\n<TITLE>%s %s Retrieval Set</TITLE>\n</HEAD>\n<BODY>',folder,base);
    fprintf(retFID,'\n<center>\n');
    retInds = FindRetrievalSet(trainGlobalDesc,SelectDesc(testGlobalDesc,i,1),HOMETESTSET,fullfile(folder,base),testParams);
    fprintf(retFID,'<img width="%d" src="%s"> ',min(co,maxDim),[backOutString '../Images/' folder '/' base ext]);% width="400"
    for retSetSize = testParams.retSetSize
        retSetSize = min(retSetSize, length(retInds));
        imInds = retInds(1:retSetSize);
        fprintf(retFID,'<H1>%d image retrieval set</H1>',retSetSize);
        fprintf(retFID,'\n<table border="0">\n');
        count = 0;
        for imInd = imInds(:)'
            [retFolder retBase retExt] = fileparts(trainFileList{imInd});
            localImageFile = fullfile(HOMEWEB,'Images',retFolder,[retBase retExt]);make_dir(localImageFile);
            if(~exist(localImageFile,'file'))
                copyfile(fullfile(HOMEIMAGES,trainFileList{imInd}),localImageFile);
            end
            fprintf(retFID,'\t\t<td><center><a href="%s">',[backOutString '../Images/' retFolder '/' retBase retExt]);
            fprintf(retFID,'<img width="%d" src="%s"> ',200,[backOutString '../Images/' retFolder '/' retBase retExt]);% width="400"
            fprintf(retFID,'</a></center> </td>\n');
            count = count +1;
            if(count == numCols)
                count = 0;
                fprintf(retFID,'\t</tr><tr VALIGN=TOP>\n');
            end
        end
        fprintf(retFID,'\t<tr VALIGN=TOP>\n');
        fprintf(retFID,'\t</tr>\n</table></center>');
    end
    fprintf(retFID,'</BODY>\n</HTML>');
    fclose(retFID);
    
    
    if(isfield(testParams,'RetrievalMetaMatch'))
        metaFields = fieldnames(testParams.TrainMetadata);
        totalMask = ones(size(retInds))==1;
        for f = 1:length(metaFields)
            mask = strcmp(testParams.TrainMetadata.(metaFields{f})(retInds),testParams.TestMetadata.(metaFields{f}){i});
            totalMask = mask&totalMask;
        end
        retInds = retInds(totalMask);
        
        retWebPage = fullfile(HOMEWEB,'RetrievalWebInOut',folder,[base '.htm']);make_dir(retWebPage);
        retFID = fopen(retWebPage,'w');
        fprintf(retFID,'<HTML>\n<HEAD>\n<TITLE>%s %s Retrieval Set</TITLE>\n</HEAD>\n<BODY>',folder,base);
        fprintf(retFID,'\n<center>\n');
        fprintf(retFID,'<img width="%d" src="%s"> ',min(co,maxDim),[backOutString '../Images/' folder '/' base ext]);% width="400"
        for retSetSize = testParams.retSetSize
            retSetSize = min(retSetSize, length(retInds));
            imInds = retInds(1:retSetSize);
            fprintf(retFID,'<H1>%d image retrieval set</H1>',retSetSize);
            fprintf(retFID,'\n<table border="0">\n');
            count = 0;
            for imInd = imInds(:)'
                [retFolder retBase retExt] = fileparts(trainFileList{imInd});
                localImageFile = fullfile(HOMEWEB,'Images',retFolder,[retBase retExt]);make_dir(localImageFile);
                if(~exist(localImageFile,'file'))
                    copyfile(fullfile(HOMEIMAGES,trainFileList{imInd}),localImageFile);
                end
                fprintf(retFID,'\t\t<td><center><a href="%s">',[backOutString '../Images/' retFolder '/' retBase retExt]);
                fprintf(retFID,'<img width="%d" src="%s"> ',200,[backOutString '../Images/' retFolder '/' retBase retExt]);% width="400"
                fprintf(retFID,'</a></center> </td>\n');
                count = count +1;
                if(count == numCols)
                    count = 0;
                    fprintf(retFID,'\t</tr><tr VALIGN=TOP>\n');
                end
            end
            fprintf(retFID,'\t<tr VALIGN=TOP>\n');
            fprintf(retFID,'\t</tr>\n</table></center>');
        end
        fprintf(retFID,'</BODY>\n</HTML>');
        fclose(retFID);
    end
    %}
    
    %% Per Image Webpage
    imageWebPage = fullfile(HOMEWEB,'ImageWeb',folder,[base '.htm']);make_dir(imageWebPage);
    if(~justIndex)
        imFID = fopen(imageWebPage,'w');
        fprintf(imFID,'<HTML>\n<HEAD>\n<TITLE>%s %s</TITLE>\n</HEAD>\n<BODY>',folder,base);
        fprintf(imFID,'<SCRIPT LANGUAGE="JAVASCRIPT" TYPE="TEXT/JAVASCRIPT">\n<!--\nvar lAreas = false;\nvar lLegend = false;\nvar files = new Array();\n');
    end
    fileBase = cell(0);
    webFileBase = cell(0);
    for j = 1:length(WebTestList)
        for k = 1:length(WEBLABELSETS)
            [foo setBase] = fileparts(WEBLABELSETS{k});
            fileBase{end+1} = fullfile(HOMEWEB,setBase,WebTestList{j},folder,base);make_dir(fileBase{end});
            webFileBase{end+1} = [backOutString '../' setBase '/' WebTestList{j} '/' folder '/' base];
        end
    end
    
    if(~justIndex)
        for j = 1:length(fileBase)
            fprintf(imFID,'files[%d] = "%s";\n',j,webFileBase{j});
        end
        fprintf(imFID,'function roll_over(img_name, i, over)\n{\n\tif(over){\n\t\tdocument[img_name].src = files[i]+"Correct.png";}\n');
        fprintf(imFID,'\telse{\n\t\tif(lAreas){\n\t\t\tdocument[img_name].src = files[i]+"LArea.png";\n\t\t}\n');
        fprintf(imFID,'\t\telse if(lLegend){\n\t\t\tdocument[img_name].src = files[i]+"NoLegend.png";\n\t\t}\n');
        fprintf(imFID,'\t\telse{\n\t\t\tdocument[img_name].src = files[i]+".png";}\n\t}\n}\n');
        fprintf(imFID,'function switch_larea(){\n\tlAreas=~lAreas;\n\tlLegend=false;\n\tfor(var i = 1; i < files.length; i++)\n\t{\n\t\timg_name = "im_"+i.toString();\n');
        fprintf(imFID,'\t\tif(lAreas){\n\t\t\tdocument[img_name].src = files[i]+"LArea.png";\n\t\t}\n');
        fprintf(imFID,'\t\telse if(lLegend){\n\t\t\tdocument[img_name].src = files[i]+"NoLegend.png";\n\t\t}\n\t\telse{\n\t\t\tdocument[img_name].src = files[i]+".png";\n\t\t}\n\t}\n}\n');
        fprintf(imFID,'function switch_legend(){\n\tlLegend=~lLegend;\n\tlAreas=false;\n\tfor(var i = 1; i < files.length; i++)\n\t{\n\t\timg_name = "im_"+i.toString();\n');
        fprintf(imFID,'\t\tif(lAreas){\n\t\t\tdocument[img_name].src = files[i]+"LArea.png";\n\t\t}\n');
        fprintf(imFID,'\t\telse if(lLegend){\n\t\t\tdocument[img_name].src = files[i]+"NoLegend.png";\n\t\t}\n\t\telse{\n\t\t\tdocument[img_name].src = files[i]+".png";\n\t\t}\n\t}\n}\n');
        fprintf(imFID,'//-->\n</SCRIPT>\n');
        fprintf(imFID,'<A HREF="javascript:void(0)" onclick="switch_larea()">Toggle Labeled Area</a><br>');
        fprintf(imFID,'<A HREF="javascript:void(0)" onclick="switch_legend()">Toggle Legend</a>');
        fprintf(imFID,'<br>imageNum %d',i);
        fprintf(imFID,'\n<center>\n');

        fprintf(imFID,'\n<table border="0">\n');
        fprintf(imFID,'\t<tr VALIGN=TOP>\n');
        fprintf(imFID,'<td><img height="%d" src="%s"> </td>',min(ro,maxDim),[backOutString '../Images/' folder '/' base ext]);% width="400"
        fprintf(imFID,'\t</tr>\n</table><br>');
        fprintf(imFID,'\n<table border="0">\n');
        fprintf(imFID,'\t<tr VALIGN=TOP>\n');
        localImageFile = fullfile(HOMEWEB,'Images',folder,[base ext]);make_dir(localImageFile);
        copyfile(fullfile(HOMEWEBTESTIMAGES,testFileList{i}),localImageFile,'f');
        fprintf(imFID,'\t\t<td><center>%s</center>\n','Ground Truth');
        groundTruth = cell(size(WEBLABELSETS));
        %% Ground Truth
        for k = 1:length(WEBLABELSETS)
            [foo setBase] = fileparts(WEBLABELSETS{k});
            groundTruthFile = fullfile(WEBLABELSETS{k},folder,[base '.mat']);
            if(~exist(groundTruthFile,'file'))
                fprintf(imFID,'\t\t<td><center>%s</center>\n','No Ground Truth');
                groundTruth{k} = [];
                continue;
            end
            load(groundTruthFile); %S metaData names
            groundTruth{k} = S;
            allNames{k} = names;
            labelImOut = fullfile(HOMEWEB,'GroundTruth',setBase,folder,[base '.png']);make_dir(labelImOut);
            if(~exist(labelImOut,'file')||genIm)
                STemp = S+1;
                STemp(STemp<1) = 1;
                [imLabeled] = DrawImLabels(im,STemp,[0 0 0; labelColors{k}],{'unlabeled' names{:}},labelImOut,128,0,k,maxDim);
            end
            labelImOutNoLegend = fullfile(HOMEWEB,'GroundTruth',setBase,folder,[base 'NoLegend.png']);make_dir(labelImOut);
            if(~exist(labelImOutNoLegend,'file')||genIm)
                STemp = S+1;
                STemp(STemp<1) = 1;
                [imLabeledNL] = DrawImLabels(im,STemp,[0 0 0; labelColors{k}],{'unlabeled' names{:}},labelImOutNoLegend,0,0,k,maxDim);
            end

            fprintf(imFID,'\t\t<center>');
            fprintf(imFID,'<img  src="%s"> ',[backOutString '../GroundTruth/' setBase '/' folder '/' base '.png']);%width="800"
            fprintf(imFID,'</center> </td>\n');

        end
        [foo setBase] = fileparts(WEBLABELSETS{1});
        %% Dataterms
        labelsToShow = unique(groundTruth{k});labelsToShow(labelsToShow==0) = [];%1:length(names);%
        %{-
        dt = load(fullfile(HOMETESTSET,setBase,parserFold,folder,[base '.mat']));
        if(isfield(dt,'probPerLabel'))
            dt = dt.probPerLabel;
        elseif(isfield(dt,'prob'))
            dt = dt.prob;
        end
        imSP = load(fullfile(HOMEDESCRIPTOR,spFold,'super_pixels',folder,[base '.mat']));
        imSP = imSP.superPixels;
        dataCostPix = cell(size(WebTestList));
        
        %imSP(imSP==0) = size(dt,1)+1;
        uSP = unique(imSP);
        spMap = zeros(max(uSP),1);
        spMap(uSP) = 1:length(uSP);
        dataCostPix{1} = reshape(dt(spMap(imSP),:),[size(imSP) size(dt,2)]);
        dataCostPix{2} = load(fullfile(HOMETESTSET,'ExemplarDataTerm',detectorFold,folder,[base '.mat']));
        dataCostPix{2} = dataCostPix{2}.dataTerm;
        dataCostPix{3} = load(fullfile(HOMETESTSET,svmFold,testSVMList{1},'Predictors',folder,[base '.mat']));
        dataCostPix{3} = reshape(dataCostPix{3}.predictors,[ro co size(dataCostPix{3}.predictors,2)]);
        dataCostPix(4:end) = [];
        %}
        %{
        dataCostPix{1} = load(fullfile(HOMETESTSET,svmFold,testSVMList{1},'Predictors',folder,[base '.mat']));
        dataCostPix{1} = reshape(dataCostPix{1}.predictors,[ro co size(dataCostPix{1}.predictors,2)]);
        dataCostPix{2} = load(fullfile(HOMETESTSET,'PerObjDataTerms',detectorFold,testSVMList{1},folder,[base '.mat']));
        dataCostPix{2}.objDataTerms = reshape(cell2mat(dataCostPix{2}.objDataTerms),[ro co size(dataCostPix{2}.objDataTerms,2)]);
        %}
        %{
        dataCostPix{3} = load(fullfile(HOMETESTSET,'SVMs\RBF-SS320k-RH0.00-RHD0.00-RE0.33-G0.0076\Predictors',folder,[base '.mat']));
        dataCostPix{3} = reshape(dataCostPix{3}.predictors,size(imSP,1),size(imSP,2),[]);
        dataCostPix{5} = load(fullfile(HOMETESTSET,'SVMs\LF-RBF-SS250k-RH0.00-RE0.33-RFD3200-std-G14.0000-C2.000\Predictors',folder,[base '.mat']));
        dataCostPix{5} = reshape(dataCostPix{5}.predictors,size(imSP,1),size(imSP,2),[]);
        dataCostPix{8} = load(fullfile(HOMETESTSET,'SVMs\LF-RBF-SS250k-RH0.00-RE0.33-RFD3-std-G0.0000-C0.063\Predictors',folder,[base '.mat']));
        dataCostPix{8} = reshape(dataCostPix{8}.predictors,size(imSP,1),size(imSP,2),[]);
        %}
        resultFile = fullfile(HOMETESTSET,mrfFold,setBase,WebTestList{2},folder,[base '.mat']);
        %{
        if(exist(resultFile,'file'))
            load(resultFile); %L Lsp labelList
            labelsToShow = union(labelsToShow, unique(L));
            labelsToShow(labelsToShow==0) = [];
        end
        %}
        fprintf(imFID,'\t</tr><tr VALIGN=TOP>\n');
    end
    fprintf(indexFID,'\t\t<td><center> <a href="%s">',['ImageWeb/' folder '/' base '.htm']);
    fprintf(indexFID,'<img  width="200" src="%s"></a> ',['Images/' folder '/' base ext]);
    if(any(i==selectedNdx))
        fprintf(selectedFID,'\t\t<td><center> <a href="%s">',['ImageWeb/' folder '/' base '.htm']);
        fprintf(selectedFID,'<img  width="200" src="%s"></a> ',['Images/' folder '/' base ext]);
    end
    
    %% per test output
    count = 1;
    if(~justIndex)
        fprintf(imFID,'\t\t<td>');
    end
    for j = 1:length(WebTestList)
        if(~justIndex)
            fprintf(imFID,'\t\t\t<center>%s</center>\n',WebTestName{j});
        end
        for k = 1:length(WEBLABELSETS)
            [foo setBase] = fileparts(WEBLABELSETS{k});
            resultFile = fullfile(HOMETESTSET,mrfFold,setBase,WebTestList{j},folder,[base '.mat']);
            
            clear Lobj objClassList
            load(resultFile); %L Lsp labelList (maybe: Lobj objClassList)
            if(~exist('Lobj','var'))
                Lobj = L;
                objClassList = 1:length(labelList);
            end
            resultCache = [resultFile '.cache'];
            if(exist(resultCache,'file'))
                load(resultCache,'-mat'); %metaData perLabelStat(#labelsx2) perPixelStat([# pix correct, # pix total]);
            end
            
            if(max(unique(L))== length(labelList)+1)
                labelList = [labelList(:)' {'unlabeled'}];
            end
            
            useLabelColors = labelColors{k}(objClassList,:);
            useLabelList = labelList(objClassList);
            
            
            
            if(~justIndex)
                labelImOutCorrect = [fileBase{count} 'Correct.png'];
                labelImOutLArea = [fileBase{count} 'LArea.png'];
                labelImOutNoLegend = [fileBase{count} 'NoLegend.png'];
                labelImOut = [fileBase{count} '.png'];
                mask = ones(size(L))==1;
                if(~isempty(groundTruth{k}))
                    mask = groundTruth{k}>0;
                    if(all(mask>0))
                        mask = groundTruth{k}>1;
                    end
                end
                if(~exist(labelImOutLArea,'file')||genIm)
                    if(isempty(groundTruth{k}))
                        [imLabeled] = DrawImLabels(im,Lobj,useLabelColors,useLabelList,labelImOutLArea,128,0,k,maxDim);
                    else
                        temp = Lobj;
                        temp(groundTruth{k}<1) = 0;
                        [imLabeled] = DrawImLabels(im,temp+1,[0 0 0; useLabelColors],{'unlabeled' useLabelList{:}},labelImOutLArea,128,0,k,maxDim);
                    end
                end
                if(~exist(labelImOutCorrect,'file')||genIm)
                    if(isempty(groundTruth{k}))
                        [imLabeled] = DrawImLabels(im,Lobj,useLabelColors,useLabelList,labelImOutCorrect,128,0,k,maxDim);
                    else
                        temp = Lobj;
                        temp(groundTruth{k}~=L) = -1;
                        temp(groundTruth{k}<1) = 0;
                        [imLabeled] = DrawImLabels(im,temp+2,[.5 0 0; 0 0 0; useLabelColors],{'wrong' 'unlabeled' useLabelList{:}},labelImOutCorrect,128,0,k,maxDim);
                    end
                end
                if(~exist(labelImOutNoLegend,'file')||genIm)
                    [imLabeled] = DrawImLabels(im,Lobj+1,[0 0 0; useLabelColors],{'unlabeled' useLabelList{:}},labelImOutNoLegend,0,0,k,maxDim);
                end
                if(~exist(labelImOut,'file')||genIm)
                    [imLabeled] = DrawImLabels(im,Lobj+1,[0 0 0; useLabelColors],{'unlabeled' useLabelList{:}},labelImOut,128,0,k,maxDim);
                end
                
                fprintf(imFID,'\t\t<center>');
                imName = sprintf('im_%d',count);
                fprintf(imFID,'<a herf="javascript:void(0)" onmouseover="roll_over(''%s'',%d,1)" onmouseout="roll_over(''%s'',%d,0)">',imName,count,imName,count);
                fprintf(imFID,'<img  src="%s" name="%s"> </a>',[webFileBase{count} '.png'],imName);
                if(exist('perPixelStat','var'))
                    fprintf(imFID,'<br>%.1f%',100*perPixelStat(1)/perPixelStat(2));
                    resultsStats(j,k,i) = perPixelStat(1)/perPixelStat(2);
                end
                fprintf(imFID,'</center> </br>\n');
            end
            count= count+1;
            if(exist('perPixelStat','var'))
                if(k==PrimaryLabelSet&&j==SecondaryTestSet)
                    secondaryRestults = 100*perPixelStat(1)/perPixelStat(2);
                end
                if(k==PrimaryLabelSet&&j==PrimaryTestSet)
                    fprintf(indexFID,'<br>%d: %.1f%',i,100*perPixelStat(1)/perPixelStat(2));
                    if(any(i==selectedNdx)); fprintf(selectedFID,'<br>%d: %.1f%',i,100*perPixelStat(1)/perPixelStat(2));end
                    if(exist('secondaryRestults','var'))
                        fprintf(indexFID,' %.1f%',(100*perPixelStat(1)/perPixelStat(2))-secondaryRestults);
                        accGain(i) = (100*perPixelStat(1)/perPixelStat(2))-secondaryRestults;
                        if(any(i==selectedNdx)); fprintf(selectedFID,' %.1f%',(100*perPixelStat(1)/perPixelStat(2))-secondaryRestults);end
                    end
                end
            end
        end
    end
    if(~justIndex)
        fprintf(imFID,'\t\t</td><td>');
    end
    if(~justIndex&&exist('dataCostPix','var')&&iscell(dataCostPix))
        for l = labelsToShow(:)'
            for j = 1:length(dataCostPix)
                if(j>2 && isstruct(dataCostPix{j}))
                    if(j>2)
                        objDataTerms = dataCostPix{2}.objDataTerms;
                        clsList = dataCostPix{2}.clsList;
                    else
                        objDataTerms = dataCostPix{j}.objDataTerms;
                        clsList = dataCostPix{j}.clsList;
                    end
                    minData = min(min(min(objDataTerms(:,:,:))));
                    maxData = max(max(max(objDataTerms(:,:,:))));
                    oNdxs = find(clsList==l);
                    if(~isempty(oNdxs))
                        oNdxs = oNdxs(min(1,length(oNdxs)):min(5,length(oNdxs)));
                    end
                    fprintf(imFID,'\t\t<center>\n');
                    minData = min(min(min(objDataTerms(:,:,oNdxs))));
                    maxData = max(max(max(objDataTerms(:,:,oNdxs))));
                    for oNdx = oNdxs(:)'
                        outfile = fullfile(HOMEWEB,'Dataterms',setBase,WebTestList{j},labelList{l},folder,[base '-' num2str(oNdx) '.png']);make_dir(outfile);
                        webFileName = [backOutString '../Dataterms/' setBase '/' WebTestList{j} '/' labelList{l} '/' folder '/' base '-' num2str(oNdx) '.png'];
                        fprintf(imFID,'\t\t<img src="%s"> <br>\n',webFileName);
                        if(~exist(outfile,'file')||genIm)
                            if(false)
                                dataTermIm = VisDataTerm( objDataTerms(:,:,oNdx), labelColors{k}(l,:), [minData maxData] );
                                imwrite(dataTermIm,outfile);
                            else
                                dataTermL =  objDataTerms(:,:,oNdx);
                                dataTermL(1,1) = minData;dataTermL(1,2) = maxData;
                                show(dataTermL,1);drawnow;
                                show(dataTermL,1);drawnow;
                                set(gcf,'PaperPositionMode','auto');
                                hold off;
                                if(~isempty(outfile))
                                    print(outfile,'-dpng','-r96');%saveas(gcf,outfname);
                                end
                            end
                        end
                    end
                    fprintf(imFID,'%s</center></br></br>\n',labelList{l});

                else
                    minData = min(min(min(dataCostPix{j}(:,:,setdiff(labelsToShow,1)))));
                    maxData = max(max(max(dataCostPix{j}(:,:,setdiff(labelsToShow,1)))));
                    %minData = min(min(min(dataCostPix{j}(:,:,l))));
                    %maxData = max(max(max(dataCostPix{j}(:,:,l))));
                    outfile = fullfile(HOMEWEB,'Dataterms',setBase,WebTestList{j},labelList{l},folder,[base '.png']);make_dir(outfile);
                    webFileName = [backOutString '../Dataterms/' setBase '/' WebTestList{j} '/' labelList{l} '/' folder '/' base '.png'];
                    fprintf(imFID,'\t\t<center><img src="%s"> <br>%s</center></br></br>\n',webFileName,labelList{l});
                    if(~exist(outfile,'file')||genIm)
                        if(false)
                            dataTermIm = VisDataTerm( dataCostPix{j}(:,:,l), labelColors{k}(l,:), [minData maxData] );
                            imwrite(dataTermIm,outfile)
                        else
                            dataTermL = dataCostPix{j}(:,:,l);
                            dataTermL(1,1) = minData;dataTermL(1,2) = maxData;
                            show(dataTermL,1);drawnow;
                            show(dataTermL,1);drawnow;
                            set(gcf,'PaperPositionMode','auto');
                            hold off;
                            if(~isempty(outfile))
                                print(outfile,'-dpng','-r96');%saveas(gcf,outfname);
                            end
                        end
                    end
                end
            end
            fprintf(imFID,'\t\t</td><td>');
        end
    end
    fprintf(indexFID,'<br><a href="%s">Retrieval Set</a>\n',['RetrievalWeb/' folder '/' base '.htm']);
    %fprintf(indexFID,'<br><a href="%s">Retrieval InOut</a>\n',['RetrievalWebInOut/' folder '/' base '.htm']);
    fprintf(indexFID,'</center> </td>\n');
    colCount = colCount +1;
    if(colCount == numCols)
        colCount = 0;
        fprintf(indexFID,'\t</tr><tr VALIGN=TOP>\n');
    end
    if(any(i==selectedNdx))
        fprintf(selectedFID,'<br><a href="%s">Retrieval Set</a>\n',['RetrievalWeb/' folder '/' base '.htm']);
        fprintf(selectedFID,'</center> </td>\n');
        colCountSelected = colCountSelected +1;
        if(colCountSelected == numCols)
            colCountSelected = 0;
            fprintf(selectedFID,'\t</tr><tr VALIGN=TOP>\n');
        end
    end
    if(~justIndex)
        fprintf(imFID,'\t</tr>\n</table></center>');
        fprintf(imFID,'</BODY>\n</HTML>');
        fclose(imFID);
    end
    dataCostPix = [];
    ProgressBar(pfig,find(range==i),length(range));
end
close(pfig);
fprintf(indexFID,'\t</tr>\n</table></center>');
fclose(indexFID);
fprintf(selectedFID,'\t</tr>\n</table></center>');
fclose(selectedFID);
